#include <iostream>
#include <map>
#include <vector>

using namespace std;

const int maxn = 1005;

typedef pair<int, int> edge;
edge make_edge (int u, int v) {
  return make_pair(min(u, v), max(u, v));
}

map<edge, string> color;
int vis [maxn];
vector<int> adj [maxn];
void dfs (int vertex, int col) {
  vis[vertex] = 1;
  for (int nxt : adj[vertex]) {
    if (!vis[nxt]) {
      if (col == 1) {
        color[make_edge(vertex, nxt)] = "sinine";
      } else {
        color[make_edge(vertex, nxt)] = "punane";
      }
      dfs(nxt, -col);
    }
  }
}

int main () {
  int vertexc, edgec;
  cin >> vertexc >> edgec;

  vector<edge> edges;
  for (int i = 0; i < edgec; i++) {
    int u, v;
    cin >> u >> v;

    adj[u].push_back(v);
    adj[v].push_back(u);
    edges.push_back(make_edge(u, v));
  }
  
  color[make_edge(1, 2)] = "punane";
  color[make_edge(2, 3)] = "sinine";
  color[make_edge(3, 4)] = "punane";
  color[make_edge(4, 1)] = "sinine";
  color[make_edge(1, 3)] = "sinine";
  for (int i = 1; i <= 4; i++) {
    vis[i] = 1;
  }

  dfs(1, -1);
  dfs(2, 1);
  dfs(3, -1);
  dfs(4, 1);

  for (edge e : edges) {
    if (color.count(e) == 0) {
      cout << "sinine" << '\n';
    } else {
      cout << color[e] << '\n';
    }
  }
}
