#include<iostream>
#include<vector>
#include<set>
#include<random>
using namespace std;

mt19937 randgen;
vector<pair<int, int> > edges;
set<pair<int, int> > taken;

bool add_edge(int u, int v) {
    if(v < u) {
        swap(u, v);
    }
    if(u == v || taken.count({u, v})) {
        return false;
    }
    edges.push_back({u, v});
    taken.insert({u, v});
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    int seed;
    int n;
    int comp_lb, comp_ub;
    
    cin >> seed >> n >> comp_lb >> comp_ub;
    randgen.seed(seed);
    
    vector<vector<int> > comp;
    comp.reserve(n);
    
    int ind = 0;
    
    while(1) {
        int cn = randgen() % (comp_ub - comp_lb + 1) + comp_lb;
        if(ind + cn > n) {
            break;
        }
        
        int ci = (int)comp.size();
        comp.push_back({});
        
        for(int i=0; i<cn; i++) {
            comp[ci].push_back(ind + i+1);
        }
        for(int i=1; i<cn; i++) {
            add_edge(comp[ci][randgen()%i], comp[ci][i]);
        }
        
        int extra = randgen() % (cn+1);
        
        for(int i=0; i<extra; i++) {
            add_edge(comp[ci][randgen()%cn], comp[ci][randgen()%cn]);
        }
        
        ind += cn;
    }
        
    for(int i=1; i<(int)comp.size(); i++) {
        int pi = randgen() % i;
        add_edge(comp[pi][randgen()%comp[pi].size()], comp[i][randgen()%comp[i].size()]);
    }
    
    cout << ind << ' ' << edges.size() << '\n';
    
    for(auto c : edges) {
        cout << c.first << ' ' << c.second << '\n';
    }
    
    return 0;
}