#include <iostream>
#include <fstream>
#include <vector>
#include <stack>
using namespace std;

int n, m;
vector< pair<int, long long int> > adj_list[100000];

int reached = 0;
long long int voltages[100000];
int fst, nextnode;
long long int nextvoltage;
bool contradiction;
stack< pair<int, long long int> > nodestack;
pair<int, long long int> fromstack;

int main() {
    ifstream fin;
    fin.open("pingesis.txt");
    fin >> n >> m;
    
    int i_node, j_node;
    long long int u;
    for (int i = 0; i < m; i++) {
        fin >> i_node >> j_node >> u;
        pair<int, long long int> p1;
        p1.first = j_node-1;
        p1.second = -u;
        adj_list[i_node-1].push_back(p1);
        pair<int, long long int> p2;
        p2.first = i_node-1;
        p2.second = u;
        adj_list[j_node-1].push_back(p2);
    }
    
    for (int i = 0; i < 100000; i++) {
        voltages[i] = 50000000001;
    }
    
    while (reached < n) {
        while (voltages[fst] != 50000000001) fst++;
        
        voltages[fst] = 0;
        for (vector< pair<int, long long int> >::iterator it = adj_list[fst].begin(); it != adj_list[fst].end(); ++it) {
            nodestack.push(*it);
        }
        reached++;
        
        while (!nodestack.empty()) {
            fromstack = nodestack.top();
            nodestack.pop();
            if (voltages[fromstack.first] != 50000000001) {
                if (voltages[fromstack.first] != fromstack.second) {
                    contradiction = true;
                    break;
                }
            }
            else {
                voltages[fromstack.first] = fromstack.second;
                reached++;
                for (vector< pair<int, long long int> >::iterator it = adj_list[fromstack.first].begin(); it != adj_list[fromstack.first].end(); ++it) {
                    pair<int, long long int> p;
                    p.first = it->first;
                    p.second = it->second + fromstack.second;
                    nodestack.push(p);
                }
            }
        }
        
        if (contradiction) break;
    }
    
    ofstream fout;
    fout.open("pingeval.txt");
    if (contradiction) {
        fout << "EI" << endl;
    }
    else {
        fout << "JAH" << endl;
    }
    fout.close();
    
    return 0;
}
