#!/usr/bin/env python3
from argparse import ArgumentParser
import random as r

argp = ArgumentParser()
argp.add_argument('-n', '--max-n', help='Max size of memory', type=int, default=0x10000)
argp.add_argument('-v', '--max-v', help='Max value', type=int, default=1000000000)
argp.add_argument('-q', '--max-q', help='Max number of queries', type=int, default=100000)
argp.add_argument('-b', '--max-b', help='Max number of address bits', type=int, default=16)
argp.add_argument('-m', '--maximize', help='Generate maximum size input', default=False,
                  action='store_true')
argp.add_argument('-p', '--force-parity', default=None, type=int,
                  help='Fix the parity of all queries')
argp.add_argument('-w', '--weight', default=None, type=str,
                  help='Hamming weight of queries (low, high)')
args = argp.parse_args()

def gen_q():
	q = r.getrandbits(args.max_b)
	if args.weight == 'high':
		q |= r.getrandbits(args.max_b)
		q |= r.getrandbits(args.max_b)
	if args.weight == 'low':
		q &= r.getrandbits(args.max_b)
		q &= r.getrandbits(args.max_b)
	if args.force_parity != None:
		q &= ~1
		q |= args.force_parity
	return q

def gen_size(lo, hi):
	if args.maximize:
		lo = hi
	return r.randint(lo, hi)

n = gen_size(1, args.max_n)
q = gen_size(1, args.max_q)

print(n, q)
for _ in range(n):
	print(r.randint(0, args.max_v))
for _ in range(q):
	print(gen_q())
